//Douglas Fjällrud, Axel Blomén Grupp 35
package src.rsa;

import java.math.BigInteger;
import java.util.Random;

public class Main {
    public static void main(String[] args) {
        System.out.println("=== Startar RSA-programmet ===");

        int bitLength = 512;
        RSAKeyGenerator rsa = new RSAKeyGenerator(bitLength);
        BigInteger[] publicKey = rsa.getPublicKey();
        BigInteger[] privateKey = rsa.getPrivateKey();

        System.out.println("\n--- Genererade nycklar ---");
        System.out.println("Publik nyckel:  N = " + publicKey[0] + ", e = " + publicKey[1]);
        System.out.println("Privat nyckel:  N = " + privateKey[0] + ", d = " + privateKey[1]);

        BigInteger message = new BigInteger(bitLength - 1, new Random());
        System.out.println("\nOriginal meddelande: " + message);

        BigInteger ciphertext = RSAEncryptor.encrypt(message, publicKey);
        System.out.println("Krypterat meddelande: " + ciphertext);

        BigInteger decrypted = RSAEncryptor.decrypt(ciphertext, privateKey);
        System.out.println("Dekrypterat meddelande: " + decrypted);

        boolean isCorrect = message.equals(decrypted);
        System.out.println("\nStämmer dekrypteringen? " + (isCorrect ? "JA! ✅" : "NEJ ❌"));
    }
}
