//Douglas Fjällrud, Axel Blomén Grupp 35
package src.rsa;

import java.math.BigInteger;

public class RSAEncryptor {

    public static BigInteger encrypt(BigInteger message, BigInteger[] publicKey) {
        BigInteger N = publicKey[0];
        BigInteger e = publicKey[1];
        return message.modPow(e, N); 
    }    

    public static BigInteger decrypt(BigInteger ciphertext, BigInteger[] privateKey) {
        BigInteger N = privateKey[0];
        BigInteger d = privateKey[1];
        return ciphertext.modPow(d, N); 
    }    

    public static void main(String[] args) {
        System.out.println("=== Test av RSA Kryptering/Dekryptering ===");
    
        RSAKeyGenerator rsa = new RSAKeyGenerator(512);
        BigInteger[] publicKey = rsa.getPublicKey();
        BigInteger[] privateKey = rsa.getPrivateKey();
    
        BigInteger message = new BigInteger("123456789");
        testEncryptionDecryption(message, publicKey, privateKey);
        
        testEncryptionDecryption(BigInteger.ZERO, publicKey, privateKey);
        
        testEncryptionDecryption(BigInteger.ONE, publicKey, privateKey);
    }

    private static void testEncryptionDecryption(BigInteger message, BigInteger[] publicKey, BigInteger[] privateKey) {
        System.out.println("\nTestar meddelande: " + message);
        
        BigInteger ciphertext = encrypt(message, publicKey);
        System.out.println("Krypterat meddelande: " + ciphertext);
    
        BigInteger decrypted = decrypt(ciphertext, privateKey);
        System.out.println("Dekrypterat meddelande: " + decrypted);
    
        System.out.println("Stämmer dekrypteringen? " + message.equals(decrypted));
    }
}
